        .align	2
        .globl	swapThreadOut
        .align	2
        .globl	swapThreadIn
        .align	2
        .globl	_swapContextOut
        .align	2
        .globl	_swapContextIn
        
	.text

#
# _ c o n t e x t O u t
#
# This procedure is called by swapThreadOut
#        

        .ent    _contextOut
_contextOut:                     
        .set noat       
        stq     $0,-512($sp)
        stq     $1,-504($sp)
        stq     $2,-496($sp)
        stq     $3,-488($sp)
        stq     $4,-480($sp)
        stq     $5,-472($sp)
        stq     $6,-464($sp)
        stq     $7,-456($sp)
        stq     $8,-448($sp)
        stq     $9,-440($sp)
        stq     $10,-432($sp)
        stq     $11,-424($sp)
        stq     $12,-416($sp)
        stq     $13,-408($sp)
        stq     $14,-400($sp)
        stq     $15,-392($sp)
        stq     $16,-384($sp)
        stq     $17,-376($sp)
        stq     $18,-368($sp)
        stq     $19,-360($sp)
        stq     $20,-352($sp)
        stq     $21,-344($sp)
        stq     $22,-336($sp)
        stq     $23,-329($sp)
        stq     $24,-320($sp)
        stq     $25,-312($sp)
        stq     $26,-304($sp)
        stq     $27,-296($sp)
        stq     $28,-288($sp)
        stq     $29,-280($sp)
        stq     $31,-264($sp)
        stt     $f0,-256($sp)
        stt     $f1,-248($sp)
        stt     $f2,-240($sp)
        stt     $f3,-232($sp)
        stt     $f4,-224($sp)
        stt     $f5,-216($sp)
        stt     $f6,-208($sp)
        stt     $f7,-200($sp)
        stt     $f8,-192($sp)
        stt     $f9,-184($sp)
        stt     $f10,-176($sp)
        stt     $f11,-168($sp)
        stt     $f12,-160($sp)
        stt     $f13,-152($sp)
        stt     $f14,-144($sp)
        stt     $f15,-136($sp)
        stt     $f16,-128($sp)
        stt     $f17,-120($sp)
        stt     $f18,-112($sp)
        stt     $f19,-104($sp)
        stt     $f20,-96($sp)
        stt     $f21,-88($sp)
        stt     $f22,-80($sp)
        stt     $f23,-72($sp)
        stt     $f24,-64($sp)
        stt     $f25,-56($sp)
        stt     $f26,-48($sp)
        stt     $f27,-40($sp)
        stt     $f28,-32($sp)
        stt     $f29,-24($sp)
        stt     $f30,-16($sp)
        stt     $f31,-8($sp)
        mt_fpcr $f6
	stt	$f6,-520($sp)
        rduniq
	stq	$0,-528($sp)
        mov     0x2000,$4       # swap port
        pmsg    $sp,$4
        lcu     $0,$0           # context stopped
        .end    _contextOut


        
#
# s w a p T h r e a d O u t
#
# Makes a context to dump all its regsiters on its stack and stop.
#
# FIXMEDM:      
#   This function cannot be used for stopping several contexts
#   unless stops serialized.
#        
# parameters:   
#    $16 context
#    $17 (sp)
#    $18 (pc)        
#
        .ent swapThreadOut
swapThreadOut:
        spcs    $0,$16                   # reading PC/stopping
        stq     $0,0($18)                # store PC value
        lda     $0,_contextOut
        lpcr    $0,$16                   # swap out routine
        mov     0x2000,$0
        gmsg    $0,$0                   # reading thread's stack pointer
        stq     $0,0($17)
        ret	zero,($26),0x1
        .end swapThreadOut

                




#
# _ c o n t e x t I n
#
# This procedure is called by swapThreadIn
#        

        .ent    _contextIn
        .set noat
_contextIn:                     
        mov     0x2001,$4       # swapin port
        gmsg    $sp,$4
        ldq     $16,-528($sp)
	wruniq
	ldt	$f6,-520($sp)
        mf_fpcr $f6
        ldt     $f0,-256($sp)
        ldt     $f1,-248($sp)
        ldt     $f2,-240($sp)
        ldt     $f3,-232($sp)
        ldt     $f4,-224($sp)
        ldt     $f5,-216($sp)
        ldt     $f6,-208($sp)
        ldt     $f7,-200($sp)
        ldt     $f8,-192($sp)
        ldt     $f9,-184($sp)
        ldt     $f10,-176($sp)
        ldt     $f11,-168($sp)
        ldt     $f12,-160($sp)
        ldt     $f13,-152($sp)
        ldt     $f14,-144($sp)
        ldt     $f15,-136($sp)
        ldt     $f16,-128($sp)
        ldt     $f17,-120($sp)
        ldt     $f18,-112($sp)
        ldt     $f19,-104($sp)
        ldt     $f20,-96($sp)
        ldt     $f21,-88($sp)
        ldt     $f22,-80($sp)
        ldt     $f23,-72($sp)
        ldt     $f24,-64($sp)
        ldt     $f25,-56($sp)
        ldt     $f26,-48($sp)
        ldt     $f27,-40($sp)
        ldt     $f28,-32($sp)
        ldt     $f29,-24($sp)
        ldt     $f30,-16($sp)
        ldt     $f31,-8($sp)
        ldq     $0,-512($sp)
        ldq     $1,-504($sp)
        ldq     $2,-496($sp)
        ldq     $3,-488($sp)
        ldq     $4,-480($sp)
        ldq     $5,-472($sp)
        ldq     $6,-464($sp)
        ldq     $7,-456($sp)
        ldq     $8,-448($sp)
        ldq     $9,-440($sp)
        ldq     $10,-432($sp)
        ldq     $11,-424($sp)
        ldq     $12,-416($sp)
        ldq     $13,-408($sp)
        ldq     $14,-400($sp)
        ldq     $15,-392($sp)
        ldq     $16,-384($sp)
        ldq     $17,-376($sp)
        ldq     $18,-368($sp)
        ldq     $19,-360($sp)
        ldq     $20,-352($sp)
        ldq     $21,-344($sp)
        ldq     $22,-336($sp)
        ldq     $23,-329($sp)
        ldq     $24,-320($sp)
        ldq     $25,-312($sp)
        ldq     $26,-304($sp)
        ldq     $27,-296($sp)
        ldq     $28,-288($sp)

        mov     0x2001,$29
        pmsg    $sp,$29         # send message to creator

        ldq     $29,-280($sp)
        ldq     $31,-264($sp)
        lcu     $0,$0           # context stopped
        .end    _contextIn
                
        
#
# s w a p T h r e a d I n
#
# Makes a context to load thread.
#
# parameters:   
#    $16 context
#    $17 sp
#    $18 pc        
#

        
        .ent swapThreadIn
swapThreadIn:  
	subq	$sp,$sp,64
	stq	$8,16($sp)
	stq	$9,24($sp)
        lda     $2,_contextIn
        lpcr    $2,$16                   # swap in routine
        mov     0x2001,$2
        pmsg    $17,$2                   # sending sp
        gmsg    $2,$2                   # waiting for semicompletion...
_sTI:   scu     $2,$0          
        mov     0x1,$9
        sll     $8,$9,$16
        and     $2,$2,$8
        bne     $0,$2,_sTI                
        lpcr    $18,$16                   # here the context is stopped
	ldq	$8,16($sp)
	ldq	$9,24($sp)
	addq	$sp,$sp,64
        ret	zero,($26),0x1
        .end swapThreadIn

